diff -r 69c543cd85c6 trytond/modules/product_cost_fifo/product.py
--- a/trytond/modules/product_cost_fifo/product.py	Fri Jun 08 19:34:09 2012 +0200
+++ b/trytond/modules/product_cost_fifo/product.py	Mon Sep 24 20:36:41 2012 +0200
@@ -1,66 +1,61 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-import copy
 import datetime
-from trytond.model import ModelView, ModelSQL
 from trytond.transaction import Transaction
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 
+__all__ = ['Template']
+__metaclass__ = PoolMeta
 
-class Template(ModelSQL, ModelView):
-    _name = "product.template"
 
-    def __init__(self):
-        super(Template, self).__init__()
+class Template:
+    __name__ = 'product.template'
+
+    @classmethod
+    def __setup__(cls):
+        super(Template, cls).__setup__()
         new_sel = ('fifo', 'FIFO')
-        if new_sel not in self.cost_price_method.selection:
-            self.cost_price_method = copy.copy(self.cost_price_method)
-            self.cost_price_method.selection.append(new_sel)
-            self._reset_columns()
+        if new_sel not in cls.cost_price_method.selection:
+            cls.cost_price_method.selection.append(new_sel)
 
-    def get_fifo_move(self, template_id, quantity=0.0):
+    def get_fifo_move(self, quantity=0.0):
         '''
         Return a list of (move, qty) where move is the move to be
         consumed and qty is the quantity (in the product default uom)
         to be consumed on this move. The list contains the "first in"
         moves for the given quantity.
-
-        :param template_id: the product template id
-        :param quantity: the quantity to be removed from the stock
-        :return: list of (move, qty) where move is a browse record,
-        qty is a float
         '''
         pool = Pool()
-        move_obj = pool.get('stock.move')
-        uom_obj = pool.get('product.uom')
-        location_obj = pool.get('stock.location')
+        Move = pool.get('stock.move')
+        Uom = pool.get('product.uom')
+        Location = pool.get('stock.location')
 
-        locations = location_obj.search([
+        locations = Location.search([
             ('type', '=', 'storage'),
             ])
         stock_date_end = datetime.date.today()
-
-        with Transaction().set_context(locations=locations,
+        location_ids = [l.id for l in locations]
+        with Transaction().set_context(locations=location_ids,
                 stock_date_end=stock_date_end):
-            template = self.browse(template_id)
+            template = Template(self.id)
         offset = 0
         limit = Transaction().cursor.IN_MAX
         avail_qty = template.quantity
         fifo_moves = []
 
         while avail_qty > 0.0:
-            move_ids = move_obj.search([
+            moves = Move.search([
                 ('product.template.id', '=', template.id),
                 ('state', '=', 'done'),
                 ('from_location.type', '=', 'supplier'),
                 ], offset=offset, limit=limit,
                 order=[('effective_date', 'DESC'), ('id', 'DESC')])
-            if not move_ids:
+            if not moves:
                 break
             offset += limit
 
-            for move in move_obj.browse(move_ids):
-                qty = uom_obj.compute_qty(move.uom,
+            for move in moves:
+                qty = Uom.compute_qty(move.uom,
                         move.quantity - move.fifo_quantity,
                         template.default_uom, round=False)
                 avail_qty -= qty
@@ -76,5 +71,3 @@
 
         fifo_moves.reverse()
         return fifo_moves
-
-Template()
diff -r 38fae63d7afa trytond/modules/product_cost_history/__init__.py
--- a/trytond/modules/product_cost_history/__init__.py	Fri Jun 08 19:34:10 2012 +0200
+++ b/trytond/modules/product_cost_history/__init__.py	Mon Sep 24 20:36:41 2012 +0200
@@ -1,5 +1,16 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .ir import *
 from .product import *
+
+
+def register():
+    Pool.register(
+        Property,
+        ProductCostHistory,
+        module='product_cost_history', type_='model')
+    Pool.register(
+        OpenProductCostHistory,
+        module='product_cost_history', type_='wizard')
diff -r 38fae63d7afa trytond/modules/product_cost_history/ir.py
--- a/trytond/modules/product_cost_history/ir.py	Fri Jun 08 19:34:10 2012 +0200
+++ b/trytond/modules/product_cost_history/ir.py	Mon Sep 24 20:36:41 2012 +0200
@@ -1,10 +1,11 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-from trytond.model import ModelView, ModelSQL
+from trytond.pool import PoolMeta
 
+__all__ = ['Property']
+__metaclass__ = PoolMeta
 
-class Property(ModelSQL, ModelView):
-    _name = 'ir.property'
+
+class Property:
+    __name__ = 'ir.property'
     _history = True
-
-Property()
diff -r 38fae63d7afa trytond/modules/product_cost_history/product.py
--- a/trytond/modules/product_cost_history/product.py	Fri Jun 08 19:34:10 2012 +0200
+++ b/trytond/modules/product_cost_history/product.py	Mon Sep 24 20:36:41 2012 +0200
@@ -6,24 +6,27 @@
 from trytond.pool import Pool
 from trytond.transaction import Transaction
 
+__all__ = ['ProductCostHistory', 'OpenProductCostHistory']
+
 
 class ProductCostHistory(ModelSQL, ModelView):
     'History of Product Cost'
-    _name = 'product.product.cost_history'
-    _description = __doc__
+    __name__ = 'product.product.cost_history'
     _rec_name = 'date'
-
     template = fields.Many2One('product.template', 'Product')
     date = fields.DateTime('Date')
     cost_price = fields.Numeric('Cost Price')
 
-    def __init__(self):
-        super(ProductCostHistory, self).__init__()
-        self._order.insert(0, ('date', 'DESC'))
+    @classmethod
+    def __setup__(cls):
+        super(ProductCostHistory, cls).__setup__()
+        cls._order.insert(0, ('date', 'DESC'))
 
-    def table_query(self):
-        property_obj = Pool().get('ir.property')
-        field_obj = Pool().get('ir.model.field')
+    @staticmethod
+    def table_query():
+        pool = Pool()
+        Property = pool.get('ir.property')
+        Field = pool.get('ir.model.field')
         return ('SELECT '
                     'MAX(h.__id) AS id, '
                     'MAX(h.create_uid) AS create_uid, '
@@ -34,38 +37,33 @@
                     'CAST(TRIM(\',\' FROM SUBSTRING(h.res FROM \',.*\')) AS '
                         'INTEGER) AS template, '
                     'CAST(TRIM(\',\' FROM h.value) AS NUMERIC) AS cost_price '
-                'FROM "' + property_obj._table + '__history" h '
-                    'JOIN "' + field_obj._table + '" f ON (f.id = h.field) '
+                'FROM "' + Property._table + '__history" h '
+                    'JOIN "' + Field._table + '" f ON (f.id = h.field) '
                 'WHERE f.name = \'cost_price\' '
                     'AND h.res LIKE \'product.template,%%\' '
                 'GROUP BY h.id, COALESCE(h.write_date, h.create_date), h.res, '
                     'h.value',
                 [])
 
-ProductCostHistory()
-
 
 class OpenProductCostHistory(Wizard):
     'Open Product Cost History'
-    _name = 'product.product.cost_history.open'
+    __name__ = 'product.product.cost_history.open'
     start_state = 'open'
-
     open = StateAction('product_cost_history.act_product_cost_history_form')
 
-    def do_open(self, session, action):
+    def do_open(self, action):
         pool = Pool()
-        product_obj = pool.get('product.product')
+        Product = pool.get('product.product')
 
         active_id = Transaction().context.get('active_id')
         if not active_id or active_id < 0:
             action['pyson_domain'] = PYSONEncoder().encode([
-                ('template', '=', False),
-            ])
+                    ('template', '=', None),
+                    ])
         else:
-            product = product_obj.browse(active_id)
+            product = Product(active_id)
             action['pyson_domain'] = PYSONEncoder().encode([
-                ('template', '=', product.template.id),
-            ])
+                    ('template', '=', product.template.id),
+                    ])
         return action, {}
-
-OpenProductCostHistory()
diff -r bb71ef821e32 trytond/modules/product_measurements/__init__.py
--- a/trytond/modules/product_measurements/__init__.py	Fri Jun 08 19:34:11 2012 +0200
+++ b/trytond/modules/product_measurements/__init__.py	Mon Sep 24 20:36:41 2012 +0200
@@ -1,4 +1,11 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from product import *
+
+
+def register():
+    Pool.register(
+        Template,
+        module='product_measurements', type_='model')
diff -r bb71ef821e32 trytond/modules/product_measurements/product.py
--- a/trytond/modules/product_measurements/product.py	Fri Jun 08 19:34:11 2012 +0200
+++ b/trytond/modules/product_measurements/product.py	Mon Sep 24 20:36:41 2012 +0200
@@ -1,14 +1,17 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-from trytond.model import Model, fields
+from trytond.model import fields
 from trytond.pyson import Eval, Bool, Id
-from trytond.pool import Pool
+from trytond.pool import PoolMeta
+
+__all__ = ['Template']
+__metaclass__ = PoolMeta
 
 NON_MEASURABLE = ['service']
 
 
-class Template(Model):
-    _name = 'product.template'
+class Template:
+    __name__ = 'product.template'
 
     length = fields.Float('Length',
         digits=(16, Eval('length_digits', 2)),
@@ -24,7 +27,7 @@
             },
         depends=['type', 'length'])
     length_digits = fields.Function(fields.Integer('Length Digits',
-            on_change_with=['length_uom']), 'get_field_digits')
+            on_change_with=['length_uom']), 'on_change_with_length_digits')
     height = fields.Float('Height',
         digits=(16, Eval('height_digits', 2)),
         states={
@@ -39,7 +42,7 @@
             },
         depends=['type', 'height'])
     height_digits = fields.Function(fields.Integer('Height Digits',
-            on_change_with=['height_uom']), 'get_field_digits')
+            on_change_with=['height_uom']), 'on_change_with_height_digits')
     width = fields.Float('Width',
         digits=(16, Eval('width_digits', 2)),
         states={
@@ -54,7 +57,7 @@
             },
         depends=['type', 'width'])
     width_digits = fields.Function(fields.Integer('Width Digits',
-            on_change_with=['width_uom']), 'get_field_digits')
+            on_change_with=['width_uom']), 'on_change_with_width_digits')
     weight = fields.Float('Weight',
         digits=(16, Eval('weight_digits', 2)),
         states={
@@ -69,48 +72,36 @@
             },
         depends=['type', 'weight'])
     weight_digits = fields.Function(fields.Integer('Weight Digits',
-            on_change_with=['weight_uom']), 'get_field_digits')
+            on_change_with=['weight_uom']), 'on_change_with_weight_digits')
 
-    def _on_change_with_field_digits(self, uom_id):
-        uom_obj = Pool().get('product.uom')
-        if uom_id:
-            uom = uom_obj.browse(uom_id)
-            return uom.digits
+    def on_change_with_length_digits(self, name=None):
+        return (self.length_uom.digits if self.length_uom
+            else self.default_length_digits())
+
+    @staticmethod
+    def default_length_digits():
         return 2
 
-    def on_change_with_length_digits(self, values):
-        return self._on_change_with_field_digits(values.get('length_uom'))
+    def on_change_with_height_digits(self, name=None):
+        return (self.height_uom.digits if self.height_uom
+            else self.default_height_digits())
 
-    def default_length_digits(self):
+    @staticmethod
+    def default_height_digits():
         return 2
 
-    def on_change_with_height_digits(self, values):
-        return self._on_change_with_field_digits(values.get('height_uom'))
+    def on_change_with_width_digits(self, name=None):
+        return (self.width_uom.digits if self.width_uom
+            else self.default_width_digits())
 
-    def default_height_digits(self):
+    @staticmethod
+    def default_width_digits():
         return 2
 
-    def on_change_with_width_digits(self, values):
-        return self._on_change_with_field_digits(values.get('width_uom'))
+    def on_change_with_weight_digits(self, name=None):
+        return (self.weight_uom.digits if self.weight_uom
+            else self.default_weight_digits())
 
-    def default_width_digits(self):
+    @staticmethod
+    def default_weight_digits():
         return 2
-
-    def on_change_with_weight_digits(self, values):
-        return self._on_change_with_field_digits(values.get('weight_uom'))
-
-    def default_weight_digits(self):
-        return 2
-
-    def get_field_digits(self, ids, name):
-        digits = {}
-        field = '%s_uom' % name[:-7]
-        for template in self.browse(ids):
-            uom = getattr(template, field)
-            if uom:
-                digits[template.id] = uom.digits
-            else:
-                digits[template.id] = 2
-        return digits
-
-Template()
diff -r 625672ac7f09 trytond/modules/product_price_list/__init__.py
--- a/trytond/modules/product_price_list/__init__.py	Fri Jun 08 19:34:13 2012 +0200
+++ b/trytond/modules/product_price_list/__init__.py	Mon Sep 24 20:36:41 2012 +0200
@@ -1,4 +1,11 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
+from trytond.pool import Pool
+from .price_list import *
 
-from .price_list import *
+
+def register():
+    Pool.register(
+        PriceList,
+        PriceListLine,
+        module='product_price_list', type_='model')
diff -r 625672ac7f09 trytond/modules/product_price_list/price_list.py
--- a/trytond/modules/product_price_list/price_list.py	Fri Jun 08 19:34:13 2012 +0200
+++ b/trytond/modules/product_price_list/price_list.py	Mon Sep 24 20:36:41 2012 +0200
@@ -10,6 +10,8 @@
 from trytond.pool import Pool
 from trytond.backend import TableHandler
 
+__all__ = ['PriceList', 'PriceListLine']
+
 
 # code snippet taken from http://docs.python.org/library/tokenize.html
 def decistmt(s):
@@ -44,8 +46,8 @@
 
 class PriceList(ModelSQL, ModelView):
     'Price List'
-    _name = 'product.price_list'
-    _description = __doc__
+    __name__ = 'product.price_list'
+
     name = fields.Char('Name', required=True, translate=True)
     company = fields.Many2One('company.company', 'Company', required=True,
         select=True, domain=[
@@ -54,7 +56,8 @@
             ])
     lines = fields.One2Many('product.price_list.line', 'price_list', 'Lines')
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
     def _get_context_price_list_line(self, party, product, unit_price,
@@ -74,68 +77,43 @@
             'unit_price': unit_price,
         }
 
-    def compute(self, price_list, party, product, unit_price, quantity, uom,
+    def compute(self, party, product, unit_price, quantity, uom,
             pattern=None):
         '''
         Compute price based on price list of party
 
-        :param price_list: the price list id or the BrowseRecord of the
-            product.price_list
-        :param party: the party id or the BrowseRecord of the party.party
-        :param product: the product id or the BrowseRecord of the
-            product.product
         :param unit_price: a Decimal for the default unit price in the
             company's currency and default uom of the product
         :param quantity: the quantity of product
-        :param uom: the UOM id or the BrowseRecord of the product.uom
+        :param uom: a instance of the product.uom
         :param pattern: a dictionary with price list field as key
             and match value as value
         :return: the computed unit price
         '''
-        pool = Pool()
-        party_obj = pool.get('party.party')
-        product_obj = pool.get('product.product')
-        uom_obj = pool.get('product.uom')
-        price_list_line_obj = pool.get('product.price_list.line')
 
-        if not price_list:
-            return unit_price
-
-        if isinstance(price_list, (int, long)):
-            price_list = self.browse(price_list)
-
-        if isinstance(party, (int, long)):
-            party = party_obj.browse(party)
-
-        if isinstance(product, (int, long)):
-            product = product_obj.browse(product)
-
-        if isinstance(uom, (int, long)):
-            uom = uom_obj.browse(uom)
+        Uom = Pool().get('product.uom')
 
         if pattern is None:
             pattern = {}
 
         pattern = pattern.copy()
         pattern['product'] = product and product.id or None
-        pattern['quantity'] = uom_obj.compute_qty(uom, quantity,
+        pattern['quantity'] = Uom.compute_qty(uom, quantity,
                 product.default_uom, round=False)
 
-        for line in price_list.lines:
-            if price_list_line_obj.match(line, pattern):
+        for line in self.lines:
+            if line.match(pattern):
                 with Transaction().set_context(
                         self._get_context_price_list_line(party, product,
                             unit_price, quantity, uom)):
-                    return price_list_line_obj.get_unit_price(line)
+                    return line.get_unit_price(line)
         return unit_price
 
-PriceList()
-
 
 class PriceListLine(ModelSQL, ModelView):
     'Price List Line'
-    _name = 'product.price_list.line'
-    _description = __doc__
+    __name__ = 'product.price_list.line'
+
     price_list = fields.Many2One('product.price_list', 'Price List',
             required=True, ondelete='CASCADE')
     product = fields.Many2One('product.product', 'Product')
@@ -145,105 +123,91 @@
     quantity = fields.Float('Quantity', digits=(16, Eval('unit_digits', 2)),
             depends=['unit_digits'])
     unit_digits = fields.Function(fields.Integer('Unit Digits',
-        on_change_with=['product']), 'get_unit_digits')
+        on_change_with=['product']), 'on_change_with_unit_digits')
     formula = fields.Char('Formula', required=True,
             help='Python expression that will be evaluated with:\n' \
                     '- unit_price: the original unit_price')
 
-    def __init__(self):
-        super(PriceListLine, self).__init__()
-        self._order.insert(0, ('price_list', 'ASC'))
-        self._order.insert(0, ('sequence', 'ASC'))
-        self._constraints += [
-            ('check_formula', 'invalid_formula'),
-        ]
-        self._error_messages.update({
-            'invalid_formula': 'Invalid formula!',
-        })
+    @classmethod
+    def __setup__(cls):
+        super(PriceListLine, cls).__setup__()
+        cls._order.insert(0, ('price_list', 'ASC'))
+        cls._order.insert(0, ('sequence', 'ASC'))
+        cls._constraints += [
+                ('check_formula', 'invalid_formula'),
+                ]
+        cls._error_messages.update({
+                'invalid_formula': 'Invalid formula!',
+                })
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
 
-        super(PriceListLine, self).init(module_name)
+        super(PriceListLine, cls).__register__(module_name)
 
         # Migration from 2.4: drop required on sequence
         table.not_null_action('sequence', action='remove')
 
-    def default_formula(self):
+    @staticmethod
+    def default_formula():
         return 'unit_price'
 
-    def on_change_with_unit_digits(self, vals):
-        product_obj = Pool().get('product.product')
-        if vals.get('product'):
-            product = product_obj.browse(vals['product'])
-            return product.default_uom.digits
+    def on_change_with_unit_digits(self, name=None):
+        if self.product:
+            return self.product.default_uom.digits
         return 2
 
-    def get_unit_digits(self, ids, name):
-        res = {}
-        for line in self.browse(ids):
-            if line.product:
-                res[line.id] = line.product.default_uom.digits
-            else:
-                res[line.id] = 2
-        return res
-
-    def check_formula(self, ids):
+    def check_formula(self):
         '''
         Check formula
         '''
-        price_list_obj = Pool().get('product.price_list')
-        context = price_list_obj._get_context_price_list_line(None, None,
+        pool = Pool()
+        PriceList = pool.get('product.price_list')
+        context = PriceList()._get_context_price_list_line(None, None,
                 Decimal('0.0'), 0, None)
-        lines = self.browse(ids)
+
         with Transaction().set_context(**context):
-            for line in lines:
-                try:
-                    if not isinstance(self.get_unit_price(line), Decimal):
-                        return False
-                except Exception:
+            try:
+                if not isinstance(self.get_unit_price(), Decimal):
                     return False
+            except Exception:
+                return False
         return True
 
-    def match(self, line, pattern):
+    def match(self, pattern):
         '''
         Match line on pattern
 
-        :param line: a BrowseRecord of price list line
         :param pattern: a dictonary with price list line field as key
                 and match value as value
         :return: a boolean
         '''
         res = True
         for field in pattern.keys():
-            if field not in self._columns:
+            if field not in self._fields:
                 continue
-            if not line[field]:
+            if not getattr(self, field):
                 continue
-            if self._columns[field]._type == 'many2one':
-                if line[field].id != pattern[field]:
+            if self._fields[field]._type == 'many2one':
+                if getattr(self, field).id != pattern[field]:
                     res = False
                     break
             elif field == 'quantity':
-                if line[field] > pattern[field]:
+                if getattr(self, field) > pattern[field]:
                     res = False
                     break
             else:
-                if line[field] != pattern[field]:
+                if getattr(self, field) != pattern[field]:
                     res = False
                     break
         return res
 
-    def get_unit_price(self, line):
+    def get_unit_price(self):
         '''
-        Return unit price for a line
-
-        :param line: a BrowseRecord of price list line
-        :return: a Decimal
+        Return unit price (as Decimal)
         '''
         context = Transaction().context.copy()
         context['Decimal'] = Decimal
-        return safe_eval(decistmt(line.formula), context)
-
-PriceListLine()
+        return safe_eval(decistmt(self.formula), context)
diff -r 98a16ccdf418 trytond/modules/production/__init__.py
--- a/trytond/modules/production/__init__.py	Mon Sep 10 15:28:23 2012 +0200
+++ b/trytond/modules/production/__init__.py	Mon Sep 24 20:36:41 2012 +0200
@@ -1,8 +1,31 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .configuration import *
 from .bom import *
 from .product import *
 from .production import *
 from .stock import *
+
+
+def register():
+    Pool.register(
+        Configuration,
+        BOM,
+        BOMInput,
+        BOMOutput,
+        BOMTree,
+        OpenBOMTreeStart,
+        OpenBOMTreeTree,
+        Production,
+        AssignFailed,
+        Product,
+        ProductBom,
+        Location,
+        Move,
+        module='production', type_='model')
+    Pool.register(
+        Assign,
+        OpenBOMTree,
+        module='production', type_='wizard')
